# Copyright © 2022-2023 antD97
# Licensed under the MIT License https://antD.mit-license.org/

scoreboard objectives add restricted_rockets_config trigger

# configurable max rockets
scoreboard objectives add restricted_rockets_max_rockets trigger
scoreboard players add restricted_rockets_ restricted_rockets_max_rockets 0

# global value: 0=players CANNOT override, 1=players CAN override
# per player value: 0=use GLOBAL value, 1=use PLAYER value
scoreboard objectives add restricted_rockets_override_max_rockets trigger
scoreboard players add restricted_rockets_ restricted_rockets_override_max_rockets 0

# configurable slow falling on elytra break
# per player: 0=GLOBAL value, 1=false, 2=true
scoreboard objectives add restricted_rockets_safe_elytra_break trigger
scoreboard players add restricted_rockets_ restricted_rockets_safe_elytra_break 0

# global value: 0=players CANNOT override, 1=players CAN override
scoreboard objectives add restricted_rockets_override_safe_elytra_break trigger
scoreboard players add restricted_rockets_ restricted_rockets_override_safe_elytra_break 0

# configurable rockets remaining actionbar
# global: 0=false, 1=true
# per player: 0=GLOBAL value, 1=false, 2=true
scoreboard objectives add restricted_rockets_rockets_tip trigger
scoreboard players add restricted_rockets_ restricted_rockets_rockets_tip 0

# configurable zero rockets remaining actionbar always
# global: 0=false, 1=true
# per player: 0=use GLOBAL value, 1=false, 2=true
scoreboard objectives add restricted_rockets_zero_rockets_tip_always trigger
scoreboard players add restricted_rockets_ restricted_rockets_zero_rockets_tip_always 0

# init defaults
scoreboard objectives add restricted_rockets_init dummy
scoreboard players add restricted_rockets_ restricted_rockets_init 0
execute if score restricted_rockets_ restricted_rockets_init matches 0 run function restricted_rockets:load/defaults
scoreboard players set restricted_rockets_ restricted_rockets_init 1

# rocket counts
scoreboard objectives add restricted_rockets_rockets_used minecraft.used:minecraft.firework_rocket
scoreboard objectives add restricted_rockets_rockets_used_while_flying dummy
scoreboard objectives add restricted_rockets_rockets_remaining dummy

# time since the player's flight has been cancelled
scoreboard objectives add restricted_rockets_time_since_cancelled dummy

# can be 0 (not flying), 1 (just started flying), or 2 (has been flying)
scoreboard objectives add restricted_rockets_time_flying dummy

scoreboard objectives add restricted_rockets_in_liquid dummy

scoreboard objectives add restricted_rockets_slow_falling dummy

scoreboard objectives add restricted_rockets_x_pos dummy
scoreboard objectives add restricted_rockets_y_pos dummy
scoreboard objectives add restricted_rockets_z_pos dummy

# temporary values
scoreboard objectives add restricted_rockets_temp1 dummy
scoreboard objectives add restricted_rockets_temp2 dummy
scoreboard objectives add restricted_rockets_temp3 dummy

schedule function restricted_rockets:timer/1t 1t
schedule function restricted_rockets:timer/10t 10t
